module genout_tools2
! This module only created due to circular compiler problems with the getfreeunit 
! implemented in genout_tools
implicit none

public :: getfreeunit
public :: create_dirs

contains

subroutine getfreeunit(unitnr)
integer,intent(inout) :: unitnr

integer, save :: lastused_unitnr=10

unitnr=lastused_unitnr+1
lastused_unitnr=unitnr

end subroutine getfreeunit

!--------------------------------------------------------------------
!--------------------------------------------------------------------
function get_path(file)
use dflib
  character(len=*), intent(in)	:: file
  character(256)				:: get_path

  INTEGER(4) length
  CHARACTER(3)        drive
  CHARACTER(256)      name1,path
  CHARACTER(256)      ext
  
  length = splitpathqq(file, drive, path, name1, ext)
  get_path=path
end function

!--------------------------------------------------------------------
!--------------------------------------------------------------------

subroutine create_dirs(path)
use dflib
  character(len=*), intent(in) :: path

  CHARACTER(256) d1,d2
  INTEGER(4) length
  CHARACTER(3)        drive
  CHARACTER(256)      dir1,dir2,dir3,dir4
  CHARACTER(256)      name1,name2
  CHARACTER(256)      ext
  LOGICAL(4)          result
  integer             q

  ! current directory
  result=GETDRIVEDIRQQ (d1) 
  length = splitpathqq(d1, drive, dir1, name1, ext)
  dir1=trim(dir1)//trim(name1)

  ! requested directory
  d2 = trim(path)
  length = splitpathqq(d2, drive, dir2, name2, ext)

  dir3=dir2(len_trim(dir1)+2:len_trim(dir2)-1)

  q=index(dir3,'\')
  do while (q>0)
    dir4=dir3(1:q-1)
    result = MAKEDIRQQ(dir3(1:q-1))
	result = changedirqq(dir3(1:q-1))
	dir3=dir3(q+1:len_trim(dir3))
	q=index(dir3,'\')
  enddo
  dir4=dir3  
  result = MAKEDIRQQ(dir4)
  result = CHANGEDIRQQ(d1)
end subroutine create_dirs


end module